"""
------------------------------------------------------------------------------
           Name: test_send_sms.py
         Author: Daniele De Santis (desantis@areasx.com)
        Version: 1.0
  Last Modified: 15/01/07
    Description: Test Invio SMS
                 Esempio in Python 1.5 per Modem TELIT GM862-PY su SxPY.
          Note : 
------------------------------------------------------------------------------
"""

import MDM
import GPIO
import MOD
import sys

#Numero del destinatario
_GSMNUMBER = "34785xxxxx"
#Centro servizzi dell'operatore
#TIM +393359607000
#VODAFONE +393492000200
_SERVICE_CENTER = "+393492000200"  #Usare il +39!!

#SETTO LA DIREZIONE DEI PORT
r=GPIO.setIOdir(2,0,1) #LED TEST
r=GPIO.setIOdir(6,0,1) #RELE' K1
r=GPIO.setIOdir(7,0,1) #RELE' K2
r=GPIO.setIOdir(1,0,0) #INPUT 1
r=GPIO.setIOdir(8,0,0) #INPUT 2 e PULSANTE TEST

#-------------------------
# FUNZIONI
#-------------------------

#Verifica la presenza e inizializza il modem
def InitModem():
  res = MDM.send('AT\r', 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #RNONicevuto "OK"
    return -1
  #Attivo la modalit TEXT
  res = MDM.send("AT+CMGF=1\r", 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #NON Ricevuto "OK"
    return -2
  #setta il centro servizzi
  TXbuff="AT+CSCA=\"%s\",145\r" % (_SERVICE_CENTER)
  res = MDM.send(TXbuff, 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #NON Ricevuto "OK"
    return -3
  else:
    return 1
    
#Invia un SMS 
def SendSMS(gsmnumber, message):
  TXbuff="AT+CMGS=\"%s\"\r" % (gsmnumber)
  res = MDM.send(TXbuff, 0)
  #attendo il >
  timer=MOD.secCounter()
  while(1):
    res = MDM.receive(6)
    #print res
    if (MOD.secCounter()>timer+5): #Timeout 5 sec 
      return -1
      break
    if(res.find('>') != -1):
      break
  #Invio il testo dell'SMS
  TXbuff = message + chr(26) + "\r" #appendo CTRL + Z
  res = MDM.send(TXbuff, 0) #invio la stringa al modem
  timer=MOD.secCounter()
  while(1):
    res = MDM.receive(2) #Attendo 2 sec
    print res
    if (MOD.secCounter()>timer+10): #Timeout 10 sec
      return -2
      break
    if(res.find('ERROR') != -1): #Ricevuto errore
      return 0
      break
    if(res.find('OK') != -1):
      return 1
      break
  

#-------------------------
#FINE FUNZIONI
#-------------------------


#-------------------------
# PROGRAMMA PRINCIPALE
#-------------------------
print "\r\nTEST INVIO SMS\r\n"

res= InitModem()
for i in range(1,10):
  if(res!=1):
    print "ERRORE inizializzazione del modem fallita. CODE %d\r\n" % res
  else:
    print "inizializzazione Modem OK\r\n"
    break
    
if(res!=1):
  sys.exit(0)
  
while (1):
  s=GPIO.setIOvalue(2,0) #LED TEST ON
  if(GPIO.getIOvalue(8)==0): #Pressione tasto TEST
    print "Tasto TEST premuto :D\r\n"
    s=GPIO.setIOvalue(2,1) #ON
    s=GPIO.setIOvalue(6,1) #Rel ON
    #Invia Un sms con le coordinate
    res = SendSMS(_GSMNUMBER, "Ciao sono un SMS di prova dalla SxPY:)")
    if(res==1):
      print "Invio SMS riuscito\r\n"
    else:
      print "ERRORE Invio SMS fallito. CODE %d\r\n" % res
    MOD.sleep(20) #2 secondi pausa
    s=GPIO.setIOvalue(6,0) #Rel ON
    s=GPIO.setIOvalue(2,0) #ON
  else:
    s=GPIO.setIOvalue(2,1) #LED TEST OFF